/* Convert the value of the user to number */
export const setSize = (userSize, screenSize) => {
  let regExp = new RegExp('\\d+(vh|vw|%)');
  let regExpPx = new RegExp('((?<=[a-zA-Z])(?=[0-9]))|((?<=[0-9])(?=[a-zA-Z]))')
  if (regExp.test(userSize)) {
    return ((userSize.split(regExpPx)[0] / 100) * screenSize);
  } else {
    return Number.parseInt(userSize.split(regExpPx)[0]);
  }
}

/* Return selectable rows */
export const selectableRows = (rows) => {
  rows = rows.map(row => {
    row.o2DatatableRowSelected = row.o2DatatableRowSelected === undefined ? false : row.o2DatatableRowSelected;
    return row;
  });
  return rows;
}

/* Calculate the width of a columnsToDisplay from the colSize property */
export const setColumnsWidth = (columns, dimensionsComponent) => {
  let totalWidthColumn = 0;
  let widthDatatable = dimensionsComponent.datatable.width;
  
  columns.forEach(column => {
    if(column.id !== "selectable"){             
      column.width = column.colSize * 15;
      
      if(column.width < 100){          
        column.width = 100;
      }
    }else{
      column.width = 48;
    }
    
    totalWidthColumn += column.width;
  });
  
  if(widthDatatable > totalWidthColumn){
    columns.forEach(column => {
      if(column.inputType === 'checkbox'){
        totalWidthColumn -= column.width;
        widthDatatable -= column.width;
      }
    });
    
    let multiplier = widthDatatable / totalWidthColumn;
    
    columns.forEach(column => {
      if(column.inputType !== 'checkbox'){
        column.width = column.width * multiplier;
      }
    });
  }
  
  return columns;
}